﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;

namespace OpenCDDrive
{
	/// <summary>
	/// Class that contains various utilities for working with the CD Drive
	/// </summary>
	class CDController
	{
		/// <summary>Sends a command to open the CD Drive</summary>
		public static void OpenCDDrive()
		{
			CDController.mciSendString("set CDAudio door open", (StringBuilder)null, (int)sbyte.MaxValue, 0);
		}

		/// <summary>Sends a command to close the CD Drive</summary>
		public static void CloseCDDrive()
		{
			CDController.mciSendString("set CDAudio door closed", (StringBuilder)null, (int)sbyte.MaxValue, 0);
		}

		// -------------------------------------------------------------------------------------------------------------------------
		// Imports

		/// <summary>Sends a command to the MCI (Media Control Interface)</summary>
		/// <param name="lpstrCommand">Command to execute</param>
		/// <param name="lpstrReturnString">Gets the return value from the call (if any)</param>
		/// <param name="uReturnLength">The size of the buffer for the return string (should pass sbyte.MaxValue)</param>
		/// <param name="hwndCallback">Handle to a callback window if appropriate</param>
			/// <returns></returns>
		[DllImport("winmm.dll", EntryPoint = "mciSendStringA")]
		public static extern int mciSendString(string lpstrCommand, StringBuilder lpstrReturnString, int uReturnLength, int hwndCallback);

		[DllImport("kernel32.dll", EntryPoint = "GetVolumeInformationA")]
		public static extern int GetVolumeInformation(string lpRootPathName, StringBuilder lpVolumeNameBuffer, int nVolumeNameSize, int lpVolumeSerialNumber, int lpMaximumComponentLength, int lpFileSystemFlags, string lpFileSystemNameBuffer, int nFileSystemNameSize);

		[DllImport("kernel32.dll", EntryPoint = "GetDriveTypeA")]
		public static extern int GetDriveType(string nDrive);
	}
}
